import { Set, List, OrderedSet } from "immutable";
import { TypeGraph } from "./TypeGraph";
import { Type } from "./Type";
export declare type DeclarationKind = "forward" | "define";
export declare class Declaration {
    readonly kind: DeclarationKind;
    readonly type: Type;
    constructor(kind: DeclarationKind, type: Type);
    equals(other: any): boolean;
    hashCode(): number;
}
export declare class DeclarationIR {
    readonly declarations: List<Declaration>;
    readonly forwardedTypes: Set<Type>;
    constructor(declarations: List<Declaration>, forwardedTypes: Set<Type>);
}
export declare function declarationsForGraph(graph: TypeGraph, needsForwardDeclarations: boolean, childrenOfType: (t: Type) => OrderedSet<Type>, typeNeedsDeclaration: (t: Type) => boolean): DeclarationIR;
export declare function cycleBreakerTypesForGraph(graph: TypeGraph, canBeCycleBreaker: (t: Type) => boolean): Set<Type>;
